public class Collision {
	//let start over
	//it will use a serialized data form
	//it will use Point and PointList
	//every transformation applied to the Zone will be done here

	//i think i just need:
	//	sphere to sphere with boolean
	//	sphere to sphere with newtonian response
	//	sphere to plane	with boolean
	//	sphere to plane with sliding

	//the normal of a plane is calculated like so
	//normal = cross_product(p1-p2, p3-p2)
	//and the magnitude of this vector
	//k = dot_product(normal , p1)
	//if dist() < bounding_sphere + k

	//check with plane if there really need for normalisation
	//while i work always squared
	//btw , all plane will be precalculated
	//and will suffer from rotation translation
	//i think about a center with many plane arround
	//	the rule is to stay out	
}

/*

	//----------------------------------------
	//collision detection
	//----------------------------------------
	//the perfect collision detection for a space asteroid game
	public boolean collide_with_bounding_sphere_of(Point center, double bounding_sphere) {
		//the first step for collision detection is the bounding sphere
		double dist = new Point(this.center).dist(center);
		if (dist < this.bounding_sphere+bounding_sphere) {
			return true;
		}
		return false;
	}
	public boolean collide_with_bounding_sphere_of(Model model) {
		return collide_with_bounding_sphere_of(model.center, model.bounding_sphere);
	}
	//calcutation the normal of three point (p1,p2,p3), is making the cross product of two line (p1,p2 and p2,p3)
	//normal = cross_product((p1-p2),(p3-p2))
	//k = dot_product(p1,normal);
	//to know if the point is in plane;
	//dot_product(point , normal) = k           Point is in plane 
	//dot_product(point , normal) > k           Point is on one side of plane 
	//dot_product(point , normal) < k           Point is on other side of plane
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	public Point normal_of_poly(int polynum) {
		Point p1 = this.get_point_of_poly(0, polynum);
		Point p2 = this.get_point_of_poly(1, polynum);
		Point p3 = this.get_point_of_poly(2, polynum);
		//return new Point(p1).sub(p2).cross_product(new Point(p3).sub(p2));	//too much new Point , evitate too much allocation
		//make it the hard way
			double ax = p1.x-p2.x, ay = p1.y-p2.y, az = p1.z-p2.z;
			double bx = p3.x-p2.x, by = p3.y-p2.y, bz = p3.z-p2.z;
			return new Point( (ay*bz)-(az*by), (az*bx)-(ax*bz), (ax*by)-(ay*bx) );	//cross product
	}
	//the perfect collison detection for wall
	public boolean planes_vs_bounding_sphere_of(Point point, double bounding_sphere) {
		this.absolute();
		int cnt = 0; 
		for (int i = 0; i < this.pnum; i++) {
			Point normal = this.normal_of_poly(i);
			double dist = normal.dot_product( new Point( point ).sub(this.center) );
			if (dist < bounding_sphere && dist > -bounding_sphere) {
				cnt += 1;
			}
		}
		//if (cnt >= this.polygons.num) {
		if (cnt >= this.pnum) {
			return true;
		}
		return false;
	}
	public boolean planes_vs_bounding_sphere_of(Model model) {
		return planes_vs_bounding_sphere_of(model.center, model.bounding_sphere);
	}

	//the direction and the normal have to be normalised (enormous overhead)
	//this function compare with the plane and not the polygon ...
	//i just dont know what to do with it
	public Point collision_point_of_a_direction_and_a_plane(Point p1, Point normal, Point center, Point direction) {
		double time = -( (normal.dot_product(center) + normal.dot_product(p1)) / normal.dot_product(direction) );
		return new Point(center).add(new Point(direction).mul(time)); 
	}

*/
